<template>
  <form @submit.prevent="formSubmit">
    <Title v-if="isPreview" text="Preview" />
    <RoleYourDetails
      :fields="{
        firstName: $v.firstName,
        lastName: $v.lastName,
        email: $v.email,
        phone: $v.phone
      }"
    />
    <RoleBoardExperience
      :fields="{
        boardExperience: $v.boardExperience,
        tbraProfile: $v.tbraProfile,
        tbraProfileList: $v.tbraProfileList
      }"
    />
    <RoleCurrentHistoricRoles
      :fields="{
        currentHistoricRolesList: $v.currentHistoricRolesList,
        currentHistoricRolesHeadlines: $v.currentHistoricRolesHeadlines
      }"
    />
    <RoleRequired
      :fields="{
        requiredForThisRoleSections: $v.requiredForThisRoleSections,
        requiredForThisRoleRoles: $v.requiredForThisRoleRoles
      }"
    />
    <RoleDesired
      :fields="{
        desiredForThisRoleSections: $v.desiredForThisRoleSections,
        desiredForThisRoleRoles: $v.desiredForThisRoleRoles
      }"
    />
    <RoleCoverLetter
      :fields="{
        coverLetter: $v.coverLetter
      }"
    />
    <RoleCV
      :fields="{
        cvCondition: $v.cvCondition,
        cvFile: $v.cvFile
      }"
    />

    <div class="c-button-wrapper">
      <Button
        :text="isPreview ? 'Edit' : 'Preview'"
        buttonStyle="secondary"
        :disabled="submit.isLoading"
        @clicked="setPreviewHanler()"
      />
      <Button text="Submit" type="submit" :disabled="submit.isLoading" />
    </div>

    <div class="form-loader-wrapper" v-if="submit.isLoading">
      <Loader />
    </div>

    <!--    <div v-if="submitStatus">{{ submitStatus }}</div>-->
    <ErrorMessage
      v-if="submitStatus === 'ERROR'"
      text="Please check the form for any errors."
      style="font-size: 2rem"
      align="right"
    />
  </form>
</template>

<script>
import { mapActions, mapState, mapMutations } from "vuex";
import RoleYourDetails from "./RoleYourDetails";
import RoleCoverLetter from "./RoleCoverLetter";
import { validationMixin } from "vuelidate";
import { mapFields, mapMultiRowFields } from "vuex-map-fields";
import RoleBoardExperience from "./RoleBoardExperience";
import { formValidation } from "../mixins/formValidation";
import RoleCurrentHistoricRoles from "./RoleCurrentHistoricRoles";
import RoleRequired from "./RoleRequired";
import RoleDesired from "./RoleDesired";
import RoleCV from "./RoleCV";
import Button from "../ui/Button";
import ErrorMessage from "../ui/ErrorMessage";
import Loader from "../ui/Loader";
import Title from "../ui/Title";
export default {
  name: "RoleForm",
  components: {
    Title,
    Loader,
    ErrorMessage,
    Button,
    RoleCV,
    RoleDesired,
    RoleRequired,
    RoleCurrentHistoricRoles,
    RoleBoardExperience,
    RoleYourDetails,
    RoleCoverLetter
  },
  mixins: [validationMixin, formValidation],
  data: function() {
    return {
      submitStatus: ""
    };
  },
  computed: {
    ...mapState(["submit", "isPreview"]),
    ...mapFields([
      "form.userDetails.firstName",
      "form.userDetails.lastName",
      "form.userDetails.email",
      "form.userDetails.phone",
      "form.boardExperience",
      "form.tbraProfile",
      "form.currentHistoricRolesHeadlines",
      "form.coverLetter",
      "form.cv.cvCondition",
      "form.cv.cvFile"
    ]),
    ...mapMultiRowFields([
      "form.tbraProfileList",
      "form.currentHistoricRolesList",
      "form.requiredForThisRoleSections",
      "form.requiredForThisRoleRoles",
      "form.desiredForThisRoleSections",
      "form.desiredForThisRoleRoles"
    ])
  },
  methods: {
    ...mapActions(["submitData"]),
    ...mapMutations(["setPreview", "resetState"]),
    formSubmit() {
      this.$v.$touch();
      if (this.$v.$invalid) {
        this.$store.commit("setPreview", false);
        this.submitStatus = "ERROR";
      } else {
        this.submitStatus = "";
        this.$store.dispatch("submitData");
      }
    },
    setPreviewHanler() {
      this.$v.$touch();
      if (this.$v.$invalid) {
        this.submitStatus = "ERROR";
      } else {
        this.submitStatus = "";
        this.$store.commit("setPreview", !this.$store.state.isPreview);
        window.scrollTo(0, 0);
      }
    }
  }
};
</script>

<style lang="scss">
.form-loader-wrapper {
  display: flex;
  justify-content: center;
  @include breakpoint(overPhone) {
    justify-content: flex-end;
  }
  .c-loader {
    margin: 2rem 0 0;
  }
}
</style>
